﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.Services;
using System.Web.Script.Services;
using System.Diagnostics;
using System.Reflection;
using CloudFox.Presentation;
using Newtonsoft.Json;

namespace BookmarkBrowser
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                // Needed to deal with a caching bug in Safari on iOS 6
                // See http://stackoverflow.com/questions/12506897/is-safari-on-ios-6-caching-ajax-results
                HttpContext.Current.Response.Cache.SetCacheability(HttpCacheability.NoCache);

                if (!this.IsPostBack)
                {
                    if (Session["CurrentException"] != null)
                    {
                        Response.Redirect("~/Errors/Error.aspx", false);
                    }
                }
            }
            catch (Exception ex)
            {
                Session["CurrentException"] = ex;
                Response.Redirect("~/Errors/Error.aspx", false);
            }
        }

        [WebMethod()]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static Directory LoadBookmarks(string userName, string password, string syncKey) {
            CloudFox.Weave.WeaveProxy client = BookmarkBrowserCommon.BuildClient(userName, password, syncKey);
            return BookmarkBrowserCommon.LoadBookmarks(client);
        }
    }
}
